SocketWrapperBase (Apache Tomcat 9.0.121 API Documentation)
Description: declaration: package: org.apache.tomcat.util.net, class: SocketWrapperBase

# Class SocketWrapperBase<E>

java.lang.Object
org.apache.tomcat.util.net.SocketWrapperBase<E>

Type Parameters:
  `E` - the socket type

Direct Known Subclasses:
  `AprEndpoint.AprSocketWrapper, Nio2Endpoint.Nio2SocketWrapper, NioEndpoint.NioSocketWrapper`

public abstract class SocketWrapperBase<E> extends Object
Base class for wrapping a socket connection.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static enum`
  `SocketWrapperBase.BlockingMode`
  Defines the blocking behavior for I/O operations.
  `static interface`
  `SocketWrapperBase.CompletionCheck`
  Interface for determining whether a completion handler should be invoked.
  `static enum`
  `SocketWrapperBase.CompletionHandlerCall`
  Defines the possible outcomes for completion handler invocation.
  `static enum`
  `SocketWrapperBase.CompletionState`
  Represents the completion state of an asynchronous I/O operation.
  `protected class`
  `SocketWrapperBase.OperationState<A>`
  Internal state tracker for vectored operations.
  `protected class`
  `SocketWrapperBase.VectoredIOCompletionHandler<A>`
  Completion handler for vectored operations.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected int`
  `bufferedWriteSize`
  The max size of the individual buffered write buffers
  `protected final AtomicBoolean`
  `closed`
  Indicates whether the socket has been closed.
  `static final SocketWrapperBase.CompletionCheck`
  `COMPLETE_READ`
  This utility CompletionCheck will cause the completion handler to be called once the given buffers are full.
  `static final SocketWrapperBase.CompletionCheck`
  `COMPLETE_READ_WITH_COMPLETION`
  This utility CompletionCheck will cause the completion handler to be called once the given buffers are full.
  `static final SocketWrapperBase.CompletionCheck`
  `COMPLETE_WRITE`
  This utility CompletionCheck will cause the write to fully write all remaining data.
  `static final SocketWrapperBase.CompletionCheck`
  `COMPLETE_WRITE_WITH_COMPLETION`
  This utility CompletionCheck will cause the write to fully write all remaining data.
  `protected String`
  `localAddr`
  Local address.
  `protected String`
  `localName`
  Local name.
  `protected int`
  `localPort`
  Local port.
  `protected final WriteBuffer`
  `nonBlockingWriteBuffer`
  Additional buffer used for non-blocking writes.
  `protected IOException`
  `previousIOException`
  The previous I/O exception that occurred on this socket.
  `static final SocketWrapperBase.CompletionCheck`
  `READ_DATA`
  This utility CompletionCheck will cause the completion handler to be called once some data has been read.
  `protected SocketWrapperBase<E>.OperationState<?>`
  `readOperation`
  Current read operation state.
  `protected final Semaphore`
  `readPending`
  Semaphore for pending read operations.
  `protected String`
  `remoteAddr`
  Remote address.
  `protected String`
  `remoteHost`
  Remote host.
  `protected int`
  `remotePort`
  Remote port.
  `protected static final StringManager`
  `sm`
  String manager for this class.
  `protected String`
  `sniHostName`
  SNI host name.
  `protected SocketBufferHandler`
  `socketBufferHandler`
  The buffers used for communicating with the socket.
  `protected SocketWrapperBase<E>.OperationState<?>`
  `writeOperation`
  Current write operation state.
  `protected final Semaphore`
  `writePending`
  Semaphore for pending write operations.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SocketWrapperBase(E socket, AbstractEndpoint<E,?> endpoint)`
  Creates a new socket wrapper.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `awaitReadComplete(long timeout, TimeUnit unit)`
  Deprecated.
  `boolean`
  `awaitWriteComplete(long timeout, TimeUnit unit)`
  Deprecated.
  `protected static boolean`
  `buffersArrayHasRemaining(ByteBuffer[] buffers, int offset, int length)`
  Checks if any buffer in the specified range has remaining capacity.
  `boolean`
  `canWrite()`
  Checks if the socket write buffer is writable and there is no pending non-blocking write data.
  `void`
  `checkError()`
  Throws the recorded error if one has occurred.
  `void`
  `close()`
  Close the socket wrapper.
  `abstract SendfileDataBase`
  `createSendfileData(String filename, long pos, long length)`
  Creates a sendfile data object for the specified file.
  `int`
  `decrementKeepAlive()`
  Decrements the number of keep-alive requests remaining.
  `abstract void`
  `doClientAuth(SSLSupport sslSupport)`
  Require the client to perform CLIENT-CERT authentication if it hasn't already done so.
  `protected abstract void`
  `doClose()`
  Perform the actual close.
  `protected void`
  `doWrite(boolean block)`
  Write the contents of the socketWriteBuffer to the socket.
  `protected abstract void`
  `doWrite(boolean block, ByteBuffer from)`
  Write the contents of the ByteBuffer to the socket.
  `void`
  `execute(Runnable runnable)`
  Transfers processing to a container thread.
  `boolean`
  `flush(boolean block)`
  Writes as much data as possible from any that remains in the buffers.
  `protected void`
  `flushBlocking()`
  Writes all remaining data from the buffers and blocks until the write is complete.
  `protected abstract boolean`
  `flushNonBlocking()`
  Flushes remaining buffered data using a non-blocking write.
  `Object`
  `getCurrentProcessor()`
  Returns the current processor.
  `protected AbstractEndpoint<E,?>`
  `getEndpoint()`
  Returns the endpoint.
  `IOException`
  `getError()`
  Returns the first I/O error that occurred on this socket.
  `String`
  `getLocalAddr()`
  Returns the local IP address.
  `String`
  `getLocalName()`
  Returns the local host name.
  `int`
  `getLocalPort()`
  Returns the local port number.
  `Lock`
  `getLock()`
  Returns the lock for this wrapper.
  `String`
  `getNegotiatedProtocol()`
  Returns the protocol negotiated for this connection.
  `long`
  `getReadTimeout()`
  Returns the read timeout in milliseconds.
  `String`
  `getRemoteAddr()`
  Returns the remote IP address.
  `String`
  `getRemoteHost()`
  Returns the remote host name.
  `int`
  `getRemotePort()`
  Returns the remote port number.
  `String`
  `getSniHostName()`
  Returns the SNI host name.
  `E`
  `getSocket()`
  Returns the wrapped socket.
  `SocketBufferHandler`
  `getSocketBufferHandler()`
  Returns the socket buffer handler.
  `abstract SSLSupport`
  `getSslSupport()`
  Obtain an SSLSupport instance for this socket.
  `SSLSupport`
  `getSslSupport(String clientCertProvider)`
  Deprecated.
  Will be removed in Tomcat 10.1.x onwards
  `long`
  `getWriteTimeout()`
  Returns the write timeout in milliseconds.
  `boolean`
  `hasAsyncIO()`
  Allows using NIO2 style read/write.
  `boolean`
  `hasDataToRead()`
  Checks if there is data available to read from the socket.
  `boolean`
  `hasDataToWrite()`
  Checks if there is data waiting to be written to the socket.
  `boolean`
  `hasPerOperationTimeout()`
  Allows indicating if the connector supports per operation timeout.
  `boolean`
  `isClosed()`
  Checks if the socket wrapper has been closed.
  `boolean`
  `isReadPending()`
  Allows checking if an asynchronous read operation is currently pending.
  `abstract boolean`
  `isReadyForRead()`
  Checks if the socket is ready for reading.
  `boolean`
  `isReadyForWrite()`
  Checks to see if there are any writes pending and if there are calls `registerWriteInterest()` to trigger a callback once the pending writes have completed.
  `boolean`
  `isSecure()`
  Deprecated.
  Unused.
  `boolean`
  `isUpgraded()`
  Deprecated.
  Unused.
  `boolean`
  `isWritePending()`
  Allows checking if an asynchronous write operation is currently pending.
  `boolean`
  `needSemaphores()`
  Allows indicating if the connector needs semaphores.
  `protected abstract <A> SocketWrapperBase<E>.OperationState<A>`
  `newOperationState(boolean read, ByteBuffer[] buffers, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler, Semaphore semaphore, SocketWrapperBase<E>.VectoredIOCompletionHandler<A> completion)`
  Creates a new operation state for vectored I/O operations.
  `protected abstract void`
  `populateLocalAddr()`
  Populates the cached local IP address from the underlying socket.
  `protected abstract void`
  `populateLocalName()`
  Populates the cached local host name from the underlying socket.
  `protected abstract void`
  `populateLocalPort()`
  Populates the cached local port number from the underlying socket.
  `protected int`
  `populateReadBuffer(byte[] b, int off, int len)`
  Copies available data from the internal read buffer into the provided byte array.
  `protected int`
  `populateReadBuffer(ByteBuffer to)`
  Copies available data from the internal read buffer into the provided ByteBuffer.
  `protected abstract void`
  `populateRemoteAddr()`
  Populates the cached remote IP address from the underlying socket.
  `protected abstract void`
  `populateRemoteHost()`
  Populates the cached remote host name from the underlying socket.
  `protected abstract void`
  `populateRemotePort()`
  Populates the cached remote port number from the underlying socket.
  `abstract SendfileState`
  `processSendfile(SendfileDataBase sendfileData)`
  Starts the sendfile process.
  `void`
  `processSocket(SocketEvent socketStatus, boolean dispatch)`
  Processes a socket event.
  `abstract int`
  `read(boolean block, byte[] b, int off, int len)`
  Reads data from the socket into a byte array.
  `abstract int`
  `read(boolean block, ByteBuffer to)`
  Reads data from the socket into a ByteBuffer.
  `final <A> SocketWrapperBase.CompletionState`
  `read(long timeout, TimeUnit unit, A attachment, CompletionHandler<Long, ? super A> handler, ByteBuffer... dsts)`
  Scatter read.
  `final <A> SocketWrapperBase.CompletionState`
  `read(ByteBuffer[] dsts, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler)`
  Scatter read.
  `final <A> SocketWrapperBase.CompletionState`
  `read(SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler, ByteBuffer... dsts)`
  Scatter read.
  `abstract void`
  `registerReadInterest()`
  Registers interest in read events.
  `abstract void`
  `registerWriteInterest()`
  Registers interest in write events.
  `protected void`
  `reset(E closedSocket)`
  Resets the wrapped socket with a new socket instance.
  `abstract void`
  `setAppReadBufHandler(ApplicationBufferHandler handler)`
  Sets the application-level read buffer handler.
  `void`
  `setCurrentProcessor(Object currentProcessor)`
  Sets the current processor associated with this wrapper.
  `void`
  `setError(IOException error)`
  Records the first I/O error that occurs on this socket.
  `void`
  `setKeepAliveLeft(int keepAliveLeft)`
  Sets the number of keep-alive requests remaining.
  `void`
  `setNegotiatedProtocol(String negotiatedProtocol)`
  Sets the protocol negotiated for this connection.
  `void`
  `setReadTimeout(long readTimeout)`
  Set the timeout for reading.
  `void`
  `setSecure(boolean secure)`
  Deprecated.
  Unused.
  `void`
  `setSniHostName(String sniHostName)`
  Sets the SNI host name.
  `void`
  `setUpgraded(boolean upgraded)`
  Deprecated.
  Unused.
  `void`
  `setWriteTimeout(long writeTimeout)`
  Set the timeout for writing.
  `Object`
  `takeCurrentProcessor()`
  Retrieves and clears the current processor associated with this wrapper.
  `String`
  `toString()`
  Overridden for debug purposes.
  `protected static int`
  `transfer(byte[] from, int offset, int length, ByteBuffer to)`
  Transfers data from a byte array into a ByteBuffer.
  `protected static int`
  `transfer(ByteBuffer from, ByteBuffer to)`
  Transfers data from one ByteBuffer to another.
  `void`
  `unRead(ByteBuffer returnedInput)`
  Return input that has been read to the input buffer for re-reading by the correct component.
  `protected final <A> SocketWrapperBase.CompletionState`
  `vectoredOperation(boolean read, ByteBuffer[] buffers, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler)`
  Vectored operation.
  `final void`
  `write(boolean block, byte[] buf, int off, int len)`
  Writes the provided data to the socket write buffer.
  `final void`
  `write(boolean block, ByteBuffer from)`
  Writes the provided data to the socket write buffer.
  `final <A> SocketWrapperBase.CompletionState`
  `write(long timeout, TimeUnit unit, A attachment, CompletionHandler<Long, ? super A> handler, ByteBuffer... srcs)`
  Gather write.
  `final <A> SocketWrapperBase.CompletionState`
  `write(ByteBuffer[] srcs, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler)`
  Gather write.
  `final <A> SocketWrapperBase.CompletionState`
  `write(SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler, ByteBuffer... srcs)`
  Gather write.
  `protected void`
  `writeBlocking(byte[] buf, int off, int len)`
  Writes the provided data to the socket write buffer.
  `protected void`
  `writeBlocking(ByteBuffer from)`
  Writes the provided data to the socket write buffer.
  `protected void`
  `writeNonBlocking(byte[] buf, int off, int len)`
  Transfers the data to the socket write buffer (writing that data to the socket if the buffer fills up using a non-blocking write) until either all the data has been transferred and space remains in the socket write buffer or a non-blocking write leaves data in the socket write buffer.
  `protected void`
  `writeNonBlocking(ByteBuffer from)`
  Transfers the data to the socket write buffer (writing that data to the socket if the buffer fills up using a non-blocking write) until either all the data has been transferred and space remains in the socket write buffer or a non-blocking write leaves data in the socket write buffer.
  `protected void`
  `writeNonBlockingInternal(ByteBuffer from)`
  Separate method so it can be re-used by the socket write buffer to write data to the network

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### sm

    protected static final StringManager sm
    String manager for this class.

  - ### closed

    protected final AtomicBoolean closed
    Indicates whether the socket has been closed.

  - ### previousIOException

    protected volatile IOException previousIOException
    The previous I/O exception that occurred on this socket.

  - ### localAddr

    protected String localAddr
    Local address.

  - ### localName

    protected String localName
    Local name.

  - ### localPort

    protected int localPort
    Local port.

  - ### remoteAddr

    protected String remoteAddr
    Remote address.

  - ### remoteHost

    protected String remoteHost
    Remote host.

  - ### remotePort

    protected int remotePort
    Remote port.

  - ### sniHostName

    protected String sniHostName
    SNI host name.

  - ### socketBufferHandler

    protected volatile SocketBufferHandler socketBufferHandler
    The buffers used for communicating with the socket.

  - ### bufferedWriteSize

    protected int bufferedWriteSize
    The max size of the individual buffered write buffers

  - ### nonBlockingWriteBuffer

    protected final WriteBuffer nonBlockingWriteBuffer
    Additional buffer used for non-blocking writes. Non-blocking writes need to return immediately even if the data cannot be written immediately but the socket buffer may not be big enough to hold all of the unwritten data. This structure provides an additional buffer to hold the data until it can be written. Not that while the Servlet API only allows one non-blocking write at a time, due to buffering and the possible need to write HTTP headers, this layer may see multiple writes.

  - ### readPending

    protected final Semaphore readPending
    Semaphore for pending read operations.

  - ### readOperation

    protected volatile SocketWrapperBase<E>.OperationState<?> readOperation
    Current read operation state.

  - ### writePending

    protected final Semaphore writePending
    Semaphore for pending write operations.

  - ### writeOperation

    protected volatile SocketWrapperBase<E>.OperationState<?> writeOperation
    Current write operation state.

  - ### COMPLETE_WRITE

    public static final SocketWrapperBase.CompletionCheck COMPLETE_WRITE
    This utility CompletionCheck will cause the write to fully write all remaining data. If the operation completes inline, the completion handler will not be called.

  - ### COMPLETE_WRITE_WITH_COMPLETION

    public static final SocketWrapperBase.CompletionCheck COMPLETE_WRITE_WITH_COMPLETION
    This utility CompletionCheck will cause the write to fully write all remaining data. The completion handler will then be called.

  - ### READ_DATA

    public static final SocketWrapperBase.CompletionCheck READ_DATA
    This utility CompletionCheck will cause the completion handler to be called once some data has been read. If the operation completes inline, the completion handler will not be called.

  - ### COMPLETE_READ_WITH_COMPLETION

    public static final SocketWrapperBase.CompletionCheck COMPLETE_READ_WITH_COMPLETION
    This utility CompletionCheck will cause the completion handler to be called once the given buffers are full. The completion handler will then be called.

  - ### COMPLETE_READ

    public static final SocketWrapperBase.CompletionCheck COMPLETE_READ
    This utility CompletionCheck will cause the completion handler to be called once the given buffers are full. If the operation completes inline, the completion handler will not be called.

- ## Constructor Details

  - ### SocketWrapperBase

    public SocketWrapperBase(E socket, AbstractEndpoint<E,?> endpoint)
    Creates a new socket wrapper.
    Parameters:
      `socket` - the socket to wrap
      `endpoint` - the endpoint

- ## Method Details

  - ### getSocket

    public E getSocket()
    Returns the wrapped socket.
    Returns:
      the socket

  - ### reset

    protected void reset(E closedSocket)
    Resets the wrapped socket with a new socket instance.
    Parameters:
      `closedSocket` - the new socket to wrap

  - ### getEndpoint

    protected AbstractEndpoint<E,?> getEndpoint()
    Returns the endpoint.
    Returns:
      the endpoint

  - ### getLock

    public Lock getLock()
    Returns the lock for this wrapper.
    Returns:
      the lock

  - ### getCurrentProcessor

    public Object getCurrentProcessor()
    Returns the current processor.
    Returns:
      the current processor

  - ### setCurrentProcessor

    public void setCurrentProcessor(Object currentProcessor)
    Sets the current processor associated with this wrapper.
    Parameters:
      `currentProcessor` - the processor to associate

  - ### takeCurrentProcessor

    public Object takeCurrentProcessor()
    Retrieves and clears the current processor associated with this wrapper.
    Returns:
      the previous processor, or `null` if none was set

  - ### execute

    public void execute(Runnable runnable)
    Transfers processing to a container thread.
    Parameters:
      `runnable` - The actions to process on a container thread
    Throws:
      `RejectedExecutionException` - If the runnable cannot be executed

  - ### getError

    public IOException getError()
    Returns the first I/O error that occurred on this socket.
    Returns:
      the recorded error, or `null` if no error has occurred

  - ### setError

    public void setError(IOException error)
    Records the first I/O error that occurs on this socket. Subsequent calls are ignored.
    Parameters:
      `error` - the error to record

  - ### checkError

    public void checkError() throws IOException
    Throws the recorded error if one has occurred.
    Throws:
      `IOException` - if an error was previously recorded

  - ### isUpgraded

    @Deprecated public boolean isUpgraded()
    Deprecated.
    Unused. Will be removed in Tomcat 10.
    Returns:
      `true` if the connection has been upgraded.

  - ### setUpgraded

    @Deprecated public void setUpgraded(boolean upgraded)
    Deprecated.
    Unused. Will be removed in Tomcat 10.
    Parameters:
      `upgraded` - `true` if the connection has been upgraded.

  - ### isSecure

    @Deprecated public boolean isSecure()
    Deprecated.
    Unused. Will be removed in Tomcat 10.
    Returns:
      `true` if the connection uses TLS

  - ### setSecure

    @Deprecated public void setSecure(boolean secure)
    Deprecated.
    Unused. Will be removed in Tomcat 10.
    Parameters:
      `secure` - `true` if the connection uses TLS

  - ### getNegotiatedProtocol

    public String getNegotiatedProtocol()
    Returns the protocol negotiated for this connection.
    Returns:
      the negotiated protocol, or `null` if none has been negotiated

  - ### setNegotiatedProtocol

    public void setNegotiatedProtocol(String negotiatedProtocol)
    Sets the protocol negotiated for this connection.
    Parameters:
      `negotiatedProtocol` - the negotiated protocol

  - ### getSniHostName

    public String getSniHostName()
    Returns the SNI host name.
    Returns:
      the SNI host name

  - ### setSniHostName

    public void setSniHostName(String sniHostName)
    Sets the SNI host name.
    Parameters:
      `sniHostName` - the SNI host name to set

  - ### setReadTimeout

    public void setReadTimeout(long readTimeout)
    Set the timeout for reading. Values of zero or less will be changed to -1.
    Parameters:
      `readTimeout` - The timeout in milliseconds. A value of -1 indicates an infinite timeout.

  - ### getReadTimeout

    public long getReadTimeout()
    Returns the read timeout in milliseconds.
    Returns:
      the read timeout, or -1 for infinite timeout

  - ### setWriteTimeout

    public void setWriteTimeout(long writeTimeout)
    Set the timeout for writing. Values of zero or less will be changed to -1.
    Parameters:
      `writeTimeout` - The timeout in milliseconds. A value of zero or less indicates an infinite timeout.

  - ### getWriteTimeout

    public long getWriteTimeout()
    Returns the write timeout in milliseconds.
    Returns:
      the write timeout, or -1 for infinite timeout

  - ### setKeepAliveLeft

    public void setKeepAliveLeft(int keepAliveLeft)
    Sets the number of keep-alive requests remaining.
    Parameters:
      `keepAliveLeft` - the number of keep-alive requests remaining

  - ### decrementKeepAlive

    public int decrementKeepAlive()
    Decrements the number of keep-alive requests remaining.
    Returns:
      the updated number of keep-alive requests remaining

  - ### getRemoteHost

    public String getRemoteHost()
    Returns the remote host name.
    Returns:
      the remote host name

  - ### populateRemoteHost

    protected abstract void populateRemoteHost()
    Populates the cached remote host name from the underlying socket.

  - ### getRemoteAddr

    public String getRemoteAddr()
    Returns the remote IP address.
    Returns:
      the remote IP address

  - ### populateRemoteAddr

    protected abstract void populateRemoteAddr()
    Populates the cached remote IP address from the underlying socket.

  - ### getRemotePort

    public int getRemotePort()
    Returns the remote port number.
    Returns:
      the remote port number

  - ### populateRemotePort

    protected abstract void populateRemotePort()
    Populates the cached remote port number from the underlying socket.

  - ### getLocalName

    public String getLocalName()
    Returns the local host name.
    Returns:
      the local host name

  - ### populateLocalName

    protected abstract void populateLocalName()
    Populates the cached local host name from the underlying socket.

  - ### getLocalAddr

    public String getLocalAddr()
    Returns the local IP address.
    Returns:
      the local IP address

  - ### populateLocalAddr

    protected abstract void populateLocalAddr()
    Populates the cached local IP address from the underlying socket.

  - ### getLocalPort

    public int getLocalPort()
    Returns the local port number.
    Returns:
      the local port number

  - ### populateLocalPort

    protected abstract void populateLocalPort()
    Populates the cached local port number from the underlying socket.

  - ### getSocketBufferHandler

    public SocketBufferHandler getSocketBufferHandler()
    Returns the socket buffer handler.
    Returns:
      the socket buffer handler

  - ### hasDataToRead

    public boolean hasDataToRead()
    Checks if there is data available to read from the socket.
    Returns:
      `true` since it is always safe to attempt a read

  - ### hasDataToWrite

    public boolean hasDataToWrite()
    Checks if there is data waiting to be written to the socket.
    Returns:
      `true` if there is pending write data

  - ### isReadyForWrite

    public boolean isReadyForWrite()
    Checks to see if there are any writes pending and if there are calls `registerWriteInterest()` to trigger a callback once the pending writes have completed.

    Note: Once this method has returned `false` it MUST NOT be called again until the pending write has completed and the callback has been fired. TODO: Modify `registerWriteInterest()` so the above restriction is enforced there rather than relying on the caller.

    Returns:
      `true` if no writes are pending and data can be written otherwise `false`

  - ### canWrite

    public boolean canWrite()
    Checks if the socket write buffer is writable and there is no pending non-blocking write data.
    Returns:
      `true` if the socket is ready for writing

  - ### toString

    public String toString()
    Overridden for debug purposes. No guarantees are made about the format of this message which may vary significantly between point releases.

    Overrides:
      `toString` in class `Object`

  - ### read

    public abstract int read(boolean block, byte[] b, int off, int len) throws IOException
    Reads data from the socket into a byte array.
    Parameters:
      `block` - Whether to block
      `b` - The byte array to read into
      `off` - The offset in the array
      `len` - The number of bytes to read
    Returns:
      the number of bytes read
    Throws:
      `IOException` - If an I/O error occurs

  - ### read

    public abstract int read(boolean block, ByteBuffer to) throws IOException
    Reads data from the socket into a ByteBuffer.
    Parameters:
      `block` - Whether to block
      `to` - The ByteBuffer to read into
    Returns:
      the number of bytes read
    Throws:
      `IOException` - If an I/O error occurs

  - ### isReadyForRead

    public abstract boolean isReadyForRead() throws IOException
    Checks if the socket is ready for reading.
    Returns:
      `true` if data is available to read
    Throws:
      `IOException` - If an I/O error occurs

  - ### setAppReadBufHandler

    public abstract void setAppReadBufHandler(ApplicationBufferHandler handler)
    Sets the application-level read buffer handler.
    Parameters:
      `handler` - The application buffer handler

  - ### populateReadBuffer

    protected int populateReadBuffer(byte[] b, int off, int len)
    Copies available data from the internal read buffer into the provided byte array.
    Parameters:
      `b` - the byte array to populate
      `off` - the offset in the array
      `len` - the maximum number of bytes to copy
    Returns:
      the number of bytes copied

  - ### populateReadBuffer

    protected int populateReadBuffer(ByteBuffer to)
    Copies available data from the internal read buffer into the provided ByteBuffer.
    Parameters:
      `to` - the ByteBuffer to populate
    Returns:
      the number of bytes copied

  - ### unRead

    public void unRead(ByteBuffer returnedInput)
    Return input that has been read to the input buffer for re-reading by the correct component. There are times when a component may read more data than it needs before it passes control to another component. One example of this is during HTTP upgrade. If an (arguably misbehaving client) sends data associated with the upgraded protocol before the HTTP upgrade completes, the HTTP handler may read it. This method provides a way for that data to be returned so it can be processed by the correct component.
    Parameters:
      `returnedInput` - The input to return to the input buffer.

  - ### close

    public void close()
    Close the socket wrapper.

  - ### doClose

    protected abstract void doClose()
    Perform the actual close. The closed atomic boolean guarantees this will be called only once per wrapper.

  - ### isClosed

    public boolean isClosed()
    Checks if the socket wrapper has been closed.
    Returns:
      `true` if the wrapper has been closed

  - ### write

    public final void write(boolean block, byte[] buf, int off, int len) throws IOException
    Writes the provided data to the socket write buffer. If the socket write buffer fills during the write, the content of the socket write buffer is written to the network and this method starts to fill the socket write buffer again. Depending on the size of the data to write, there may be multiple writes to the network.

    Non-blocking writes must return immediately and the byte array holding the data to be written must be immediately available for re-use. It may not be possible to write sufficient data to the network to allow this to happen. In this case data that cannot be written to the network and cannot be held by the socket buffer is stored in the non-blocking write buffer.

    Note: There is an implementation assumption that, before switching from non-blocking writes to blocking writes, any data remaining in the non-blocking write buffer will have been written to the network.

    Parameters:
      `block` - `true` if a blocking write should be used, otherwise a non-blocking write will be used
      `buf` - The byte array containing the data to be written
      `off` - The offset within the byte array of the data to be written
      `len` - The length of the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### write

    public final void write(boolean block, ByteBuffer from) throws IOException
    Writes the provided data to the socket write buffer. If the socket write buffer fills during the write, the content of the socket write buffer is written to the network and this method starts to fill the socket write buffer again. Depending on the size of the data to write, there may be multiple writes to the network.

    Non-blocking writes must return immediately and the ByteBuffer holding the data to be written must be immediately available for re-use. It may not be possible to write sufficient data to the network to allow this to happen. In this case data that cannot be written to the network and cannot be held by the socket buffer is stored in the non-blocking write buffer.

    Note: There is an implementation assumption that, before switching from non-blocking writes to blocking writes, any data remaining in the non-blocking write buffer will have been written to the network.

    Parameters:
      `block` - `true` if a blocking write should be used, otherwise a non-blocking write will be used
      `from` - The ByteBuffer containing the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### writeBlocking

    protected void writeBlocking(byte[] buf, int off, int len) throws IOException
    Writes the provided data to the socket write buffer. If the socket write buffer fills during the write, the content of the socket write buffer is written to the network using a blocking write. Once that blocking write is complete, this method starts to fill the socket write buffer again. Depending on the size of the data to write, there may be multiple writes to the network. On completion of this method there will always be space remaining in the socket write buffer.
    Parameters:
      `buf` - The byte array containing the data to be written
      `off` - The offset within the byte array of the data to be written
      `len` - The length of the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### writeBlocking

    protected void writeBlocking(ByteBuffer from) throws IOException
    Writes the provided data to the socket write buffer. If the socket write buffer fills during the write, the content of the socket write buffer is written to the network using a blocking write. Once that blocking write is complete, this method starts to fill the socket write buffer again. Depending on the size of the data to write, there may be multiple writes to the network. On completion of this method there will always be space remaining in the socket write buffer.
    Parameters:
      `from` - The ByteBuffer containing the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### writeNonBlocking

    protected void writeNonBlocking(byte[] buf, int off, int len) throws IOException
    Transfers the data to the socket write buffer (writing that data to the socket if the buffer fills up using a non-blocking write) until either all the data has been transferred and space remains in the socket write buffer or a non-blocking write leaves data in the socket write buffer. After an incomplete write, any data remaining to be transferred to the socket write buffer will be copied to the socket write buffer. If the remaining data is too big for the socket write buffer, the socket write buffer will be filled and the additional data written to the non-blocking write buffer.
    Parameters:
      `buf` - The byte array containing the data to be written
      `off` - The offset within the byte array of the data to be written
      `len` - The length of the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### writeNonBlocking

    protected void writeNonBlocking(ByteBuffer from) throws IOException
    Transfers the data to the socket write buffer (writing that data to the socket if the buffer fills up using a non-blocking write) until either all the data has been transferred and space remains in the socket write buffer or a non-blocking write leaves data in the socket write buffer. After an incomplete write, any data remaining to be transferred to the socket write buffer will be copied to the socket write buffer. If the remaining data is too big for the socket write buffer, the socket write buffer will be filled and the additional data written to the non-blocking write buffer.
    Parameters:
      `from` - The ByteBuffer containing the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### writeNonBlockingInternal

    protected void writeNonBlockingInternal(ByteBuffer from) throws IOException
    Separate method so it can be re-used by the socket write buffer to write data to the network
    Parameters:
      `from` - The ByteBuffer containing the data to be written
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### flush

    public boolean flush(boolean block) throws IOException
    Writes as much data as possible from any that remains in the buffers.
    Parameters:
      `block` - `true` if a blocking write should be used, otherwise a non-blocking write will be used
    Returns:
      `true` if data remains to be flushed after this method completes, otherwise `false`. In blocking mode therefore, the return value should always be `false`
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### flushBlocking

    protected void flushBlocking() throws IOException
    Writes all remaining data from the buffers and blocks until the write is complete.
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### flushNonBlocking

    protected abstract boolean flushNonBlocking() throws IOException
    Flushes remaining buffered data using a non-blocking write.
    Returns:
      `true` if data remains to be flushed after this method completes, otherwise `false`
    Throws:
      `IOException` - If an IO error occurs during the write

  - ### doWrite

    protected void doWrite(boolean block) throws IOException
    Write the contents of the socketWriteBuffer to the socket. For blocking writes either then entire contents of the buffer will be written or an IOException will be thrown. Partial blocking writes will not occur.
    Parameters:
      `block` - Should the write be blocking or not?
    Throws:
      `IOException` - If an I/O error such as a timeout occurs during the write

  - ### doWrite

    protected abstract void doWrite(boolean block, ByteBuffer from) throws IOException
    Write the contents of the ByteBuffer to the socket. For blocking writes either then entire contents of the buffer will be written or an IOException will be thrown. Partial blocking writes will not occur.
    Parameters:
      `block` - Should the write be blocking or not?
      `from` - the ByteBuffer containing the data to be written
    Throws:
      `IOException` - If an I/O error such as a timeout occurs during the write

  - ### processSocket

    public void processSocket(SocketEvent socketStatus, boolean dispatch)
    Processes a socket event.
    Parameters:
      `socketStatus` - The socket event status
      `dispatch` - Whether to dispatch to a worker thread

  - ### registerReadInterest

    public abstract void registerReadInterest()
    Registers interest in read events.

  - ### registerWriteInterest

    public abstract void registerWriteInterest()
    Registers interest in write events.

  - ### createSendfileData

    public abstract SendfileDataBase createSendfileData(String filename, long pos, long length)
    Creates a sendfile data object for the specified file.
    Parameters:
      `filename` - The file to send
      `pos` - The starting position in the file
      `length` - The number of bytes to send
    Returns:
      a new sendfile data object

  - ### processSendfile

    public abstract SendfileState processSendfile(SendfileDataBase sendfileData)
    Starts the sendfile process. It is expected that if the sendfile process does not complete during this call and does not report an error, that the caller will not add the socket to the poller (or equivalent). That is the responsibility of this method.
    Parameters:
      `sendfileData` - Data representing the file to send
    Returns:
      The state of the sendfile process after the first write.

  - ### doClientAuth

    public abstract void doClientAuth(SSLSupport sslSupport) throws IOException
    Require the client to perform CLIENT-CERT authentication if it hasn't already done so.
    Parameters:
      `sslSupport` - The SSL/TLS support instance currently being used by the connection that may need updating after the client authentication
    Throws:
      `IOException` - If authentication is required then there will be I/O with the client and this exception will be thrown if that goes wrong

  - ### getSslSupport

    @Deprecated public SSLSupport getSslSupport(String clientCertProvider)
    Deprecated.
    Will be removed in Tomcat 10.1.x onwards
    Obtain an SSLSupport instance for this socket.
    Parameters:
      `clientCertProvider` - The name of the client certificate provider to use. Only used by APR/native.
    Returns:
      An SSLSupport instance for this socket.

  - ### getSslSupport

    public abstract SSLSupport getSslSupport()
    Obtain an SSLSupport instance for this socket.
    Returns:
      An SSLSupport instance for this socket.

  - ### hasAsyncIO

    public boolean hasAsyncIO()
    Allows using NIO2 style read/write.
    Returns:
      `true` if the connector has the capability enabled

  - ### needSemaphores

    public boolean needSemaphores()
    Allows indicating if the connector needs semaphores.
    Returns:
      This default implementation always returns `false`

  - ### hasPerOperationTimeout

    public boolean hasPerOperationTimeout()
    Allows indicating if the connector supports per operation timeout.
    Returns:
      This default implementation always returns `false`

  - ### isReadPending

    public boolean isReadPending()
    Allows checking if an asynchronous read operation is currently pending.
    Returns:
      `true` if the endpoint supports asynchronous IO and a read operation is being processed asynchronously

  - ### isWritePending

    public boolean isWritePending()
    Allows checking if an asynchronous write operation is currently pending.
    Returns:
      `true` if the endpoint supports asynchronous IO and a write operation is being processed asynchronously

  - ### awaitReadComplete

    @Deprecated public boolean awaitReadComplete(long timeout, TimeUnit unit)
    Deprecated.
    If an asynchronous read operation is pending, this method will block until the operation completes, or the specified amount of time has passed.
    Parameters:
      `timeout` - The maximum amount of time to wait
      `unit` - The unit for the timeout
    Returns:
      `true` if the read operation is complete, `false` if the operation is still pending and the specified timeout has passed

  - ### awaitWriteComplete

    @Deprecated public boolean awaitWriteComplete(long timeout, TimeUnit unit)
    Deprecated.
    If an asynchronous write operation is pending, this method will block until the operation completes, or the specified amount of time has passed.
    Parameters:
      `timeout` - The maximum amount of time to wait
      `unit` - The unit for the timeout
    Returns:
      `true` if the read operation is complete, `false` if the operation is still pending and the specified timeout has passed

  - ### read

    public final <A> SocketWrapperBase.CompletionState read(long timeout, TimeUnit unit, A attachment, CompletionHandler<Long, ? super A> handler, ByteBuffer... dsts)
    Scatter read. The completion handler will be called once some data has been read or an error occurred. The default NIO2 behavior is used: the completion handler will be called as soon as some data has been read, even if the read has completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `timeout` - timeout duration for the read
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `handler` - to call when the IO is complete
      `dsts` - buffers
    Returns:
      the completion state (done, done inline, or still pending)

  - ### read

    public final <A> SocketWrapperBase.CompletionState read(SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler, ByteBuffer... dsts)
    Scatter read. The completion handler will be called once some data has been read or an error occurred. If a CompletionCheck object has been provided, the completion handler will only be called if the callHandler method returned true. If no CompletionCheck object has been provided, the default NIO2 behavior is used: the completion handler will be called as soon as some data has been read, even if the read has completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `block` - is the blocking mode that will be used for this operation
      `timeout` - timeout duration for the read
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `check` - for the IO operation completion
      `handler` - to call when the IO is complete
      `dsts` - buffers
    Returns:
      the completion state (done, done inline, or still pending)

  - ### read

    public final <A> SocketWrapperBase.CompletionState read(ByteBuffer[] dsts, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler)
    Scatter read. The completion handler will be called once some data has been read or an error occurred. If a CompletionCheck object has been provided, the completion handler will only be called if the callHandler method returned true. If no CompletionCheck object has been provided, the default NIO2 behavior is used: the completion handler will be called as soon as some data has been read, even if the read has completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `dsts` - buffers
      `offset` - in the buffer array
      `length` - in the buffer array
      `block` - is the blocking mode that will be used for this operation
      `timeout` - timeout duration for the read
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `check` - for the IO operation completion
      `handler` - to call when the IO is complete
    Returns:
      the completion state (done, done inline, or still pending)

  - ### write

    public final <A> SocketWrapperBase.CompletionState write(long timeout, TimeUnit unit, A attachment, CompletionHandler<Long, ? super A> handler, ByteBuffer... srcs)
    Gather write. The completion handler will be called once some data has been written or an error occurred. The default NIO2 behavior is used: the completion handler will be called, even if the write is incomplete and data remains in the buffers, or if the write completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `timeout` - timeout duration for the write
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `handler` - to call when the IO is complete
      `srcs` - buffers
    Returns:
      the completion state (done, done inline, or still pending)

  - ### write

    public final <A> SocketWrapperBase.CompletionState write(SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler, ByteBuffer... srcs)
    Gather write. The completion handler will be called once some data has been written or an error occurred. If a CompletionCheck object has been provided, the completion handler will only be called if the callHandler method returned true. If no CompletionCheck object has been provided, the default NIO2 behavior is used: the completion handler will be called, even if the write is incomplete and data remains in the buffers, or if the write completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `block` - is the blocking mode that will be used for this operation
      `timeout` - timeout duration for the write
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `check` - for the IO operation completion
      `handler` - to call when the IO is complete
      `srcs` - buffers
    Returns:
      the completion state (done, done inline, or still pending)

  - ### write

    public final <A> SocketWrapperBase.CompletionState write(ByteBuffer[] srcs, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler)
    Gather write. The completion handler will be called once some data has been written or an error occurred. If a CompletionCheck object has been provided, the completion handler will only be called if the callHandler method returned true. If no CompletionCheck object has been provided, the default NIO2 behavior is used: the completion handler will be called, even if the write is incomplete and data remains in the buffers, or if the write completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `srcs` - buffers
      `offset` - in the buffer array
      `length` - in the buffer array
      `block` - is the blocking mode that will be used for this operation
      `timeout` - timeout duration for the write
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `check` - for the IO operation completion
      `handler` - to call when the IO is complete
    Returns:
      the completion state (done, done inline, or still pending)

  - ### vectoredOperation

    protected final <A> SocketWrapperBase.CompletionState vectoredOperation(boolean read, ByteBuffer[] buffers, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler)
    Vectored operation. The completion handler will be called once the operation is complete or an error occurred. If a CompletionCheck object has been provided, the completion handler will only be called if the callHandler method returned true. If no CompletionCheck object has been provided, the default NIO2 behavior is used: the completion handler will be called, even if the operation is incomplete, or if the operation completed inline.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `read` - true if the operation is a read, false if it is a write
      `buffers` - buffers
      `offset` - in the buffer array
      `length` - in the buffer array
      `block` - is the blocking mode that will be used for this operation
      `timeout` - timeout duration for the write
      `unit` - units for the timeout duration
      `attachment` - an object to attach to the I/O operation that will be used when calling the completion handler
      `check` - for the IO operation completion
      `handler` - to call when the IO is complete
    Returns:
      the completion state (done, done inline, or still pending)

  - ### newOperationState

    protected abstract <A> SocketWrapperBase<E>.OperationState<A> newOperationState(boolean read, ByteBuffer[] buffers, int offset, int length, SocketWrapperBase.BlockingMode block, long timeout, TimeUnit unit, A attachment, SocketWrapperBase.CompletionCheck check, CompletionHandler<Long, ? super A> handler, Semaphore semaphore, SocketWrapperBase<E>.VectoredIOCompletionHandler<A> completion)
    Creates a new operation state for vectored I/O operations.
    Type Parameters:
      `A` - The attachment type
    Parameters:
      `read` - Whether this is a read operation
      `buffers` - The buffers for the operation
      `offset` - The offset in the buffer array
      `length` - The number of buffers
      `block` - The blocking mode
      `timeout` - The timeout duration
      `unit` - The timeout time unit
      `attachment` - An attachment object
      `check` - The completion check
      `handler` - The completion handler
      `semaphore` - The semaphore for synchronization
      `completion` - The vectored I/O completion handler
    Returns:
      a new operation state instance

  - ### transfer

    protected static int transfer(byte[] from, int offset, int length, ByteBuffer to)
    Transfers data from a byte array into a ByteBuffer.
    Parameters:
      `from` - the source byte array
      `offset` - the offset in the source array
      `length` - the maximum number of bytes to transfer
      `to` - the destination ByteBuffer
    Returns:
      the number of bytes transferred

  - ### transfer

    protected static int transfer(ByteBuffer from, ByteBuffer to)
    Transfers data from one ByteBuffer to another.
    Parameters:
      `from` - the source ByteBuffer
      `to` - the destination ByteBuffer
    Returns:
      the number of bytes transferred

  - ### buffersArrayHasRemaining

    protected static boolean buffersArrayHasRemaining(ByteBuffer[] buffers, int offset, int length)
    Checks if any buffer in the specified range has remaining capacity.
    Parameters:
      `buffers` - the array of ByteBuffers
      `offset` - the starting index in the array
      `length` - the number of buffers to check
    Returns:
      `true` if any buffer has remaining capacity